library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;


entity Practica1 is
Port (
     clk            : in std_logic;
     reset          : in std_logic;
     segmentos      : out std_Logic_vector(6 downto 0);
     selector       : out std_logic_vector(3 downto 0)
     );
end Practica1;


architecture Behavioral of Practica1 is

       
       signal segundos              :  std_logic_vector(3 downto 0);
       signal dec_segundos          :  std_logic_vector(3 downto 0);
       signal minutos               :  std_logic_vector(3 downto 0);
       signal dec_minutos           :  std_logic_vector(3 downto 0);

    ----------------------
    --seales divisor
    ----------------------
    
        constant MaxCount               : integer := 125000000;
        constant MaxCount2              : integer := (125/4)*(10**3); --Frecuencia de refresco 4000Hz (nuestro ojo humano). En el video pone 125000000/4000
        signal Count                    : integer range 0 to MaxCount-1;
        signal Count2                   : integer range 0 to MaxCount2-1;
    
   ----------------------
     --contantes contadores
     ----------------------    
        constant MaxCountDecenasSeg    : unsigned(3 downto 0) :="0110"; --es el numero 6 en decimal
        constant MaxCountUnidadesSeg   : unsigned(3 downto 0) :="1010"; --es el numero 10 en decimal
        constant MaxCountDecenasMin    : unsigned(3 downto 0) :="0110"; --es el numero 6 en decimal
        constant MaxCountUnidadesMin   : unsigned(3 downto 0) :="1010"; --es el numero 10 en decimal
        
        constant MaxContador           : unsigned(1 downto 0) :="11"; --es el numero 3 en decimal pq solo tengo para poner 4 numeros y empiezo en 0
                                                                        --(dec_min,min,dec,seg,seg)
                                                                          
    
     ----------------------
     --seales contador
     ----------------------
   
        signal CountDecenasSeg         : unsigned(3 downto 0);
        signal CountUnidadesSeg        : unsigned(3 downto 0);
        signal CountDecenasMin         : unsigned(3 downto 0);
        signal CountUnidadesMin        : unsigned(3 downto 0);
        
        signal Cuenta                  : unsigned (2 downto 0);
        signal BCD_digit               : unsigned(3 downto 0); 
    ----------------------
     --seales paso contadores 
     ----------------------    
 
        signal Enable             : std_logic;
        signal Enable_segundos    : std_logic;
        signal Enable_dec_segundos: std_logic;
        signal Enable_dec_minutos : std_logic;
        signal Enable_minutos     : std_logic;
        signal Enable_cambio      : std_logic;
        signal Enable_refresco    : std_logic;

    ----------------------------
    ----seleccion
    ----------------------------
    signal seleccionar        :std_logic;
    
    
    
    
begin
    ----div. de frecuencia
    process(clk,reset)
        begin
            if(reset ='1') then
                Count <= 0;
            elsif (clk'event and clk ='1')then
                    if(Count = MaxCount-1) then
                        Count <=0;
                    else
                        Count <= Count +1;
                    end if;
            end if;
    end process;
    
    Enable_segundos <= '1' when (Count = MaxCount-1)  else '0';


---cada segundo manda un pulso


---------------------------------------------------------------------------------

---contador de segundos de 0 a 9

---------------------------------------------------------------------------------

    process(clk,reset)
         begin 
             if(reset='1') then
                  CountUnidadesSeg <= "0000";  
             elsif (clk'event and clk='1') then
                   if (Enable_segundos ='1') then
                        if(CountUnidadesSeg = MaxCountUnidadesSeg-1)  then --si lo que cuento es 10-1=9 entonces lo pongo a cero
                             CountUnidadesSeg <="0000";
                        else    
                              CountUnidadesSeg <= CountUnidadesSeg +1; --mientras no llege a nueve voy sumando   
                        end if;
                   end if;
             end if;
    end process;

    ------habilito la seal cuando el contador llegue a 9 y los sea el flanco de subida del divisor 
    ------ porque se mantendra encendido durante 125MHz , tienen que coicidir ambos
    
 Enable_dec_segundos <= '1' when ((CountUnidadesSeg=(MaxCountUnidadesSeg-1)) and (Enable_segundos='1' ))else '0';
 -- pondre a 1 el enable del contador de decenas de segundo cuando CountUnidadesSeg=9, he llegado a su mximo, pongo 
 -- este ultimo a 0 y ya empiezo a contar decenas de segundo
    
 segundos <=  std_logic_vector(CountUnidadesSeg);   


--------------------------------------------------

---contador de decenas de segundos que se incremente cuando el contador de segundos llegue a 9 
---y este toma valores de 0 a 5

-------------------------------------------------
 process(clk,reset)
         begin 
             if(reset='1') then
                  CountDecenasSeg <= "0000";  
             elsif (clk'event and clk='1') then
                   if (Enable_dec_segundos ='1') then
                        if(CountDecenasSeg = MaxCountDecenasSeg-1)  then --si lo que cuento es 6-1=5 entonces lo pongo a cero
                             CountDecenasSeg <="0000";
                        else    
                              CountDecenasSeg <= CountDecenasSeg +1;  --mientras no llege a 5 voy sumando  
                        end if;
                   end if;
             end if;
    end process;
    
    
 Enable_minutos <= '1' when ((CountDecenasSeg=MaxCountDecenasSeg-1) and  (Enable_dec_segundos='1')) else '0';
 -- pondre a 1 el enable del contador de minutos cuando CountDecenasSeg=5 , he llegado a su mximo, pongo este
 -- este ultimo a 0 y ya empiezo a contar decenas de segundo                        
 dec_segundos <= std_logic_vector(CountDecenasSeg);   
                           
----------------------------------------------------------------------

---contador de minutos que se incremente cuando las decenas de segundos llegan a 5 y los segundos a 9

----------------------------------------------------------------------
 process(clk,reset)
         begin 
             if(reset='1') then
                  CountUnidadesMin <= "0000";  
             elsif (clk'event and clk='1') then
                   if (Enable_minutos ='1') then
                        if(CountUnidadesMin = MaxCountUnidadesMin-1)  then
                             CountUnidadesMin <="0000";
                        else    
                              CountUnidadesMin <= CountUnidadesMin +1;            
                        end if;
                   end if;
             end if;
    end process;
    
    
 Enable_dec_minutos <='1' when ((CountUnidadesMin = MaxCountUnidadesMin-1)  and (Enable_minutos= '1')) else '0';
 -- El enable minutos solo esta a 1 cuando los segundos llegan a 9 y CountUnidadesMin=5, entonces tendia 59
 -- que pasa a 1 minuto y se pone el 59 a 00
     
  minutos <= std_logic_vector(CountUnidadesMin);          
                         
 -------------------------------------------------------------------------
 
----contador decenas de minuto

----------------------------------------------------------------------------
process(clk,reset)
         begin 
             if(reset='1') then
                  CountDecenasMin <= "0000";  
             elsif (clk'event and clk='1') then
                   if (Enable_dec_minutos ='1') then
                        if(CountDecenasMin = CountDecenasMin-1)  then --si lo que cuento es 6-1=5 entonces lo pongo a cero
                             CountDecenasMin <="0000";                -- solo llega a 59 minutos 
                        else    
                              CountDecenasMin <= CountDecenasMin +1;            
                        end if;
                   end if;
             end if;
    end process;
    
   dec_minutos <= std_logic_vector(CountDecenasMin);     
   
     
   
-----------------------------------------------------
 --divisor de frecuencia 4
 ---------------------------------------------------                          
process(clk,reset)
     begin
         if(reset ='1') then
             Count2 <= 0;
         elsif (clk'event and clk ='1')then
                 if(Count2 = MaxCount2-1) then --Frecuencia de refresco 4000Hz (nuestro ojo humano)
                     Count2 <=0;
                 else
                     Count2 <= Count2 +1;
                 end if;
         end if;
 end process;
 
 Enable_refresco<= '1' when (Count2 = MaxCount2-1)  else '0';

-----------------------------------------------------------
-- contador hasta 4 para display
-----------------------------------------------------------
process(clk,reset)
         begin 
             if(reset='1') then
                  cuenta <= "000";  
             elsif (clk'event and clk='1') then
                   if (Enable_refresco ='1') then
                        if(cuenta = MaxContador)  then   --MaxContador=3 pq solo tengo para poner 4 n (dec_min,min,dec_seg,seg)
                             cuenta <="000";
                        else    
                              cuenta <= cuenta +1;            
                        end if;
                   end if;
             end if;
end process;


---------------------------------------------------------------
--seleccionar display // decodificador del selector (nivel alto)
---------------------------------------------------------------
with cuenta select
    selector <= "0001"  when "00",
                "0010"  when "01",
                "0100"  when "10",
                "1000"  when others; 
      
---multiplexor
with cuenta select
    BCD_digit <= CountUnidadesSeg when "00",
                 CountDecenasSeg when "01",
                 CountUnidadesMin when "10",
                 CountDecenasMin when others;
                 
        



---digitos
 with BCD_digit select
    segmentos  <= "0000001" when "0000",
                  "1001111" when "0001", 
                  "0010010" when "0010", 
                  "0000110" when "0011", 
                  "1001100" when "0100", 
                  "0100100" when "0101", 
                  "0100000" when "0110", 
                  "0001111" when "0111", 
                  "0000000" when "1000", 
                  "0000100" when "1001", 
                  "1111111" when others;

end Behavioral;
