-- Un divisor de frecuencia es un contador de ciclos de reloj
-- Tengo que hacer un contador qu ecuente el numero duficiente de ciclos de reloj como para
-- generar un overflow cada segundo. Hata cuando lo hago? Recordar que la seal de reloj de
-- nuestra placa funciona a 125 MHz 
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;


entity freqdiv is
  Port ( 
         clk            : in std_logic;
         reset          : in std_logic;
         Enable         : in std_logic;
         Output_Signal  : out std_logic);
end freqdiv;

architecture Behavioral of freqdiv is
    
    constant MaxCount: integer :=125000000; --clk de 125 MHz
    signal Count: integer range 0 to MaxCount-1;
    
begin
    
    --Contador de ciclos de reloj que genere una seal de salida cada segundo --> 1Hz
    --Generar la seal Output_Signal, sern los pulsos uno cada segundo
    process(clk,reset)
    begin
        if(reset ='1') then
            Count <=0;
        elsif(clk'event and clk ='1') then
            if(Enable='1') then
                if(Count =MaxCount-1) then
                    Count <= 0;
                else
                    Count <= Count+1;
                end if;
             end if;
         end if;
    end process;
    
    Output_Signal <= '1' when Count =MaxCount-1 else '0';
    

end Behavioral;
